routes/web.php
<?php

use App\Http\Controllers\Admin\DashboardController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\KategoriController;
use App\Http\Controllers\Admin\ListprodukController;
use App\Http\Controllers\Admin\UkuranController;
use App\Http\Controllers\Admin\DetailprodukController;
use App\Http\Controllers\Admin\TransaksiController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\DetailtransaksiController;
use App\Http\Controllers\Admin\LogtransaksiController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::resource('listproduk', ListprodukController::class);
Route::resource('kategori', KategoriController::class);  
Route::resource('ukuran', UkuranController::class);
Route::resource('detailproduk', DetailprodukController::class);
Route::get('/admin/detailproduk/{id_produk}/tambah', [DetailProdukController::class, 'createWithProduk']);
Route::post('/admin/detailproduk/{id_produk}', [DetailProdukController::class, 'store']);
Route::resource('transaksi', TransaksiController::class);
Route::resource('user', UserController::class);
Route::resource('detailtransaksi', DetailtransaksiController::class);
Route::resource('logtransaksi', LogtransaksiController::class);


// Route::get('/searchproduct', [TransaksiController::class, 'search_product']);
// Route::get('/search','TransaksiController@search');

Route::get('/cart', function () {
    $cart = session('cart');
dd($cart);
});
Route::get('/cart/tambah/{id}', [TransaksiController::class, 'tambah_cart'])->where('id', '[0-9]+');
Route::get('/cart/hapus/{id}', [TransaksiController::class, 'hapus_cart'])->where('id', '[0-9]+');
Route::post('/cart/ubah/quantity/{id}', [TransaksiController::class, 'edit_quantity']);




Route::get('/admin/dashboard', [DashboardController::class, 'index'])->name('dashboard');
//Route::get('/admin/kategori/index', [KategoriController::class, 'index'])->name('kategori');
//Route::get('admin/kategori/form', [DashboardController::class, 'create'])->name('kategori');
//Route::get('/admin/kategori/ukuran', [UkuranController::class, 'index'])->name('kategori');

//Route::get('/admin/kategori/listproduk', [ListprodukController::class, 'index'])->name('kategori');
//Route::get('/produk/create', [ListprodukController::class, 'create'] );
//Route::post('/produk', [ListprodukController::class, 'store'] );

//Route::get('admin/kategori/formkategori', [KategoriController::class, 'create'])->name('kategori');
//Route::get('admin/kategori/formukuran', [UkuranController::class, 'create'])->name('kategori');
//Route::get('admin/kategori/formlist', [ListprodukController::class, 'create'])->name('kategori');

app/Models/Transaksi.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Transaksi extends Model
{
    use HasFactory;

    protected $table = 'transaksi';

    protected $fillable =[
        'id_kasir', 'id_pembeli', 'tanggal', 'harga_total'];

    public function kasir_user()
    {
        return $this->hasOne(User::class, 'id','id_kasir');
    }

    public function pembeli_user()
    {
        return $this->hasOne(User::class, 'id','id_pembeli');
    }

    public function transaksi_detail()
    {
        return $this->hasMany(DetailTransaksi::class, 'id_transaksi','id');
    }
}

app/Http/Controllers/Admin/TransaksiController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Transaksi;
use App\Models\DetailTransaksi;
use App\Models\User;
use App\Models\Produk;
use App\Models\Ukuran;
use App\Models\DetailProduk;
use Illuminate\Http\Request;

class TransaksiController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $produk = Produk::get();
        $detail = DetailProduk::orderBy('harga', 'ASC')->get();
        $transaksi = Transaksi::orderBy('id', 'DESC')->get();
        $cart = session('cart');
        $data['kasir'] =User::where('role', 1)->get();
        $data['pembeli'] =User::where('role', 2)->get();
        // return dd($cart);
        return view('admin.transaksi.index', $data, ['detail' => $detail,'transaksi' => $transaksi,'produk' => $produk, 'cart' => $cart]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        $data['kasir'] =User::where('role', 1)->get();
        $data['pembeli'] =User::where('role', 2)->get();
        return view('admin.transaksi.form', $data);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        dd($request->all());
        //
        $rule = [
            'id_kasir' => 'required',
            'id_pembeli' => 'required',
            'harga_total' => 'required'
            // 'id_transaksi' => 'required',
            // 'id_detail_produk' => 'required',
            // 'jumlah' => 'required',
            // 'subtotal' => 'required'
        ];

        $customMessages = [
            'id_kasir.required' => 'Field Kasir Wajib Diisi!',
            'id_pembeli.required' => 'Field Pembeli Wajib Diisi!',
            'harga_total.required' => 'Field Harga Total Wajib Diisi!'
            // 'id_transaksi.required' => 'Field Kasir Wajib Diisi!',
            // 'id_detail_produk.required' => 'Field Pembeli Wajib Diisi!',
            // 'jumlah.required' => 'Field Tanggal Wajib Diisi!',
            // 'subtotal.required' => 'Field Harga Total Wajib Diisi!'
        ];

        $this->validate($request, $rule, $customMessages);
        
        $transaksi = new Transaksi;
        $transaksi->id_kasir = $request->id_kasir;
        $transaksi->id_pembeli = $request->id_pembeli;
        $transaksi->tanggal = $request->tanggal;
        $transaksi->harga_total = $request->harga_total;
        $status = $transaksi->save();


        foreach ($request->id_detail_produk as $key => $value) {
            $detailtransaksi = new DetailTransaksi;
            $detailtransaksi->id_transaksi = $transaksi->id;
            $detailtransaksi->id_detail_produk = $request->id_detail_produk[$key];
            $detailtransaksi->jumlah = $request->jumlah[$key];
            $detailtransaksi->subtotal = $request->subtotal[$key];
            $status = $detailtransaksi->save();
        }
        
        if ($status) {
            return redirect('transaksi')->with('success','Data berhasil diubah');
        }
        // else{
        //     return redirect('transaksi/create')->with('error', 'Data gagal ditambahkan');
        // }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $transaksi = Transaksi::find($id);
        $data['transaksi'] = $transaksi;
        $data['kasir'] =User::where('role', 1)->get();
        $data['pembeli'] =User::where('role', 2)->get();
        return view('admin.transaksi.form', $data);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // 
        $rule = [
            'kasir' => 'required',
            'pembeli' => 'required',
            'tanggal' => 'required',
            'harga_total' => 'required'   
        ];

        $customMessages = [
            'kasir.required' => 'Field Kasir Wajib Diisi!',
            'pembeli.required' => 'Field Pembeli Wajib Diisi!',
            'tanggal.required' => 'Field Tanggal Wajib Diisi!',
            'harga_total.required' => 'Field Harga Total Wajib Diisi!',
        ];

        $this->validate($request, $rule, $customMessages);

        $input = $request->all();

        $transaksi= Transaksi::find($id);
        $transaksi->kasir = $request->kasir;
        $transaksi->pembeli = $request->pembeli;
        $transaksi->tanggal = $request->tanggal;
        $transaksi->harga_total = $request->harga_total;

        $status = $transaksi->save();
        if ($status) {
            return redirect('transaksi')->with('success','Data berhasil diubah');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $user= Transaksi::find($id);
        $status = $user->delete();
        
        if ($status) {
            return 1;
        }else{
            return 0;
        
        }
    }


    public function search(Request $request)
    {
        $search = Transaksi::where('title','like',"%".$request->search."%")->paginate(2);
        return view('admin.transaksi.index',['transaksi'=>$search]);
    }

    public function search_product()
    {
        $query = request('query');
        $produk = DetailProduk::where("id_produk","like","%$query%")->get();
        
        return view('admin.transaksi.search', ['detail' => $produk]);
    }

    // public function cart()
    // {
    //     $cart = session('cart');
    //     return view('cart')->with('cart',$cart);
    // }

    public function tambah_cart($id)
    {
        $cart = session()->get('cart');

        // dd(request()->query());

        if(isset($cart[$id])){
            $cart[$id]['jumlah']++;
            session(['cart' => $cart]);
            return redirect('transaksi');
        };

        $detail = DetailProduk::where('id', 'like', request()->query('id_detail_product'))->first();
        $produk = Produk::find($id);
        $ukuran = Ukuran::find($detail->id_ukuran);
        // dd($detail);
        $cart[$id] = [
            "id" => $id,
            "id_detail_produk" => $detail->id,
            "id_produk" => $detail->id_produk,
            "nama_produk" => $produk->nama_produk,
            "ukuran" => $ukuran->ukuran,
            "harga" => $detail->harga,
            "jumlah" => 1
        ];

        session(['cart' => $cart]);
        // session()->put('cart', $cart);
        return redirect('transaksi');
    }

    public function hapus_cart($id)
    {
        $cart = session()->get('cart');
        unset($cart[$id]);
        session(['cart' => $cart]);
        return redirect('transaksi');
    }

    public function edit_quantity(Request $request, $id)
    {
        $cart = session()->get('cart');
        $cart[$id]['jumlah'] = $request->jumlah;
        session(['cart' => $cart]);
        return redirect('transaksi');
    }

    public function ltransaksi()
    {
        $data['logtransaksi'] = Transaksi::all();
        return view('admin.logtransaksi.index', $data);
    }




}



    
 

resources/views/admin/transaksi/form.blade.php
@extends('admin.layout.app')

@section('content')
    <!-- BEGIN: Content-->
    <div class="app-content content ">
        <div class="content-overlay"></div>
        <div class="header-navbar-shadow"></div>
        <div class="content-wrapper">
            <div class="content-header row">
                <div class="content-header-left col-md-9 col-12 mb-2">
                    <div class="row breadcrumbs-top">
                        <div class="col-12">
                            <h2 class="content-header-title float-left mb-0">Form Layouts</h2>
                            <div class="breadcrumb-wrapper">
                                <ol class="breadcrumb">
                                    <li class="breadcrumb-item"><a href="{{url('/admin/transaksi/index')}}">Home</a>
                                    </li>
                                    <li class="breadcrumb-item"><a href="#">Forms</a>
                                    </li>
                                    <li class="breadcrumb-item active"><a href="#">Form Layouts</a>
                                    </li>
                                </ol>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="content-header-right text-md-right col-md-3 col-12 d-md-block d-none">
                    <div class="form-group breadcrumb-right">
                        <div class="dropdown">
                            <button class="btn-icon btn btn-primary btn-round btn-sm dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"><i data-feather="grid"></i></button>
                            <div class="dropdown-menu dropdown-menu-right"><a class="dropdown-item" href="app-todo.html"><i class="mr-1" data-feather="check-square"></i><span class="align-middle">Todo</span></a><a class="dropdown-item" href="app-chat.html"><i class="mr-1" data-feather="message-square"></i><span class="align-middle">Chat</span></a><a class="dropdown-item" href="app-email.html"><i class="mr-1" data-feather="mail"></i><span class="align-middle">Email</span></a><a class="dropdown-item" href="app-calendar.html"><i class="mr-1" data-feather="calendar"></i><span class="align-middle">Calendar</span></a></div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="content-body">
                <!-- Basic Horizontal form layout section start -->
                <section id="basic-horizontal-layouts">
                    <div class="row justify-content-center">
                        <div class="col-md-12 col-12">
                            <div class="card">
                                <div class="card-header">
                                    <h4 class="card-title">Transaksi</h4>
                                </div>
                                <div class="card-body">
                                    <form class="form form-horizontal" method="POST" action="{{@$transaksi ? route('transaksi.update',$transaksi->id) : route('transaksi.store')}}" enctype="multipart/form-data">
                                        @csrf
                                        @if (@$transaksi)
                                        @method('patch')
                                    @endif
                                    <div class="row">
                                        <div class="col-12">
                                            <div class="form-group row">
                                                <div class="col-sm-3 col-form-label">
                                                    <label for="email-id">Kasir</label>
                                                </div>
                                                <div class="col-sm-9">
                                                    <div class="input-group input-group-merge">
                                                        <select class="form-control select" id="id_kasir" name="id_kasir" required>
                                                            <option value="">-- PILIH KASIR --</option>
                                                            @foreach ($kasir as $row)
                                                            <option value="{{$row->id}}" {{@$transaksi->id_kasir == $row->id ? "selected" : "" }}>
                                                            {{$row->nama}}
                                                            </option>
                                                            @endforeach
                                                        </select>
                                                    </div>
                                                    </div>
                                                </div>
                                            </div>
                                        
                                            <div class="col-12">
                                                <div class="form-group row">
                                                    <div class="col-sm-3 col-form-label">
                                                        <label for="email-id">Pembeli</label>
                                                    </div>
                                                    <div class="col-sm-9">
                                                        <div class="input-group input-group-merge">
                                                            <select class="form-control select" id="id_pembeli" name="id_pembeli" required>
                                                                <option value="">-- PILIH PEMBELI --</option>
                                                                @foreach ($pembeli as $row)
                                                                <option value="{{$row->id}}" {{@$transaksi->id_pembeli == $row->id ? "selected" : "" }}>
                                                                {{$row->nama}}
                                                                </option>
                                                                @endforeach
                                                            </select>
                                                        </div>
                                                        </div>
                                                    </div>
                                                </div>
                                        
                                        <div class="col-12">
                                            <div class="form-group row">
                                                <div class="col-sm-3 col-form-label">
                                                    <label for="email-id">Tanggal</label>
                                                </div>
                                                <div class="col-sm-9">
                                                    <input type="date" id="tanggal" class="form-control" name="tanggal" placeholder="Tanggal" value="{{old('tanggal', @$transaksi? $transaksi->tanggal: '')}}"/>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-12">
                                            <div class="form-group row">
                                                <div class="col-sm-3 col-form-label">
                                                    <label for="email-id">Harga Total</label>
                                                </div>
                                                <div class="col-sm-9">
                                                    <input type="text" id="harga_total" class="form-control" name="harga_total" placeholder="Harga Total" value="{{old('harga_total', @$transaksi ? $transaksi->harga_total: '')}}"/>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    </form>
                                    <div class="col-sm-9 offset-sm-3">
                                        <button type="submit" class="btn btn-primary mr-1">Submit</button>
                                        <a href="{{route('transaksi.index')}}" class="btn btn-outline-secondary">Back</a>
                                    </div>
                                </div>
                            </div>
                        </div>
                </section>
                <!-- Basic Horizontal form layout section end -->
            </div>
        </div>
    </div>
    <!-- END: Content-->
@endsection